import Specification from '../Specification';
import { OpenAPISchema, Referenced } from '../../types/open-api';
import { Schema } from '@comet-cli/types';
import { SchemaType } from '../../types/helpers';
export declare type MergedOpenAPISchema = OpenAPISchema & {
    parentRefs?: string[];
};
export default class SchemaTransformer {
    static execute(spec: Specification, ref: Referenced<OpenAPISchema>, type?: SchemaType): Schema;
    protected static transformType(schema: OpenAPISchema): string | string[] | undefined;
    protected static transformEnum(schema: OpenAPISchema): any[] | undefined;
    protected static transformDiscriminator(schema: OpenAPISchema): string | undefined;
    protected static detectType(schema: OpenAPISchema): string | undefined;
    protected static mergeAllOf(spec: Specification, schema: OpenAPISchema, $ref: string | undefined): MergedOpenAPISchema;
    protected static getCompatibleProperties(): string[];
    protected static getTypeKeywords(): {
        [key: string]: string;
    };
}
